#ifndef DEFINE_H
#define DEFINE_H

#define VER_VERSION						1u
#define VER_UPDATE						0u
#define VER_TEST						7u
#define VER_COMPILE						0u

#define TEST_LOG_ON						1u
#define TEST_LOG_ON_UDP					0u
#define DEBUG_CTRL_MODULE				0u
#define DEBUG_COVER						0u


typedef float float32;
//---------------------------------------------------------------------------------------------
//-----------------------------------------ctrl_module-----------------------------------------
#define BASE_ADDR						0x43C00000u
#define NUM_INDEX						13u				//	0 ~ 8, 9 ~ 12(EEPROM )
#define ERR_INDEX						0u

#define ARR_BUF_MARGIN					4u

#define TIMER_BASE						30000u
#define TIMER_MSEC250					27u
#define TIMER_MSEC333                   35u
#define TIMER_MSEC500					53u
#define TIMER_SEC1						105u
#define TIMER_SEC2						210u
#define TIMER_SEC3						315u
#define TIMER_SEC5						525u
#define TIMER_SEC10						1050u


//	Motor 
#define CMD_MOTOR_USER_INPUT			0xC0u
#define CMD_MOTOR_CTN_UP				0x80u
#define CMD_MOTOR_CTN_DOWN				0x40u
#define CMD_MOTOR_STOP					0x00u

//	Motor 
#define DIR_MOTOR_STOP_FOR_UP			0x00u
#define DIR_MOTOR_UP					0x01u
#define DIR_MOTOR_DOWN					0x02u
#define DIR_MOTOR_STOP_FOR_DOWN			0x03u
//#define BIT_MOTOR_STOP					0x00

//	Diagnostic 
#define NUM_DIAG_MEMBER					5u				//	Power On(7), Current Mon, Ethernet, Motor Init, Motor Pos(3)
#define BIT_MOTOR_POS					0x08u			//	Motor Position
#define BIT_MOTOR_INIT					0x10u			//	Motor Initialization
#define BIT_ETHERNET					0x20u
#define BIT_CURR_MON					0x40u
#define BIT_POWER_ON					0x80u

//	Motor 
#define NUM_MOTOR_MEMBER				4u				//	Motor Up, Down, Min Height Arrive, Max Height Arrive
#define BIT_MOTOR_UP					0x01u			//	Register Index 3
#define BIT_MOTOR_DOWN					0x02u
#define BIT_MOTOR_MIN_ARRIVE			0x04u
#define BIT_MOTOR_MAX_ARRIVE			0x10u

//	BIT DETAIL 
#define NUM_BIT_DETAIL_MEMBER			4u
#define BIT_DETAIL_STATUS_ENCODER		0x04u
#define BIT_DETAIL_STATUS_OVER_CURR		0x08u

//	BIT 
#define REG_MASK_OVER_CURR				0x04u			//	REG_IDX_4
#define REG_MASK_ENCODER_ERR			0x40u
#define REG_MASK_ENCODER_HW_RESET		0x80u

//	
#define REG_MASK_ENCODER_HW_CLEAR		0x10u			//	REG_IDX_7

//	 
//#define SINGLE_CYCLE_SCALE				21u				//	0 ~ 1023: 0 ~ 32mm
#define SINGLE_CYCLE_SCALE				21.476				//	0 ~ 1023: 0 ~ 21.51mm
#define SINGLE_BASE_SCALE				0.021
#define SINGLE_CYCLE_MAST				0x000003FFu		//	ȿbit: 10bit(0 ~ 1023)
#define MULTI_CYCLE_MAST				0x007FFC00u		//	ȿbit: 12bit(0 ~ 4095)
#define ANT_MAST_HEIGHT_MAX				5700u			//	5700mm
#define ANT_MAST_HEIGHT_MIN				0u				//	0mm

//	, , Ұ
#define SHIFT_REMOCON_ON				00u				//	bit ̵
//#define SHIFT_POWER_CTRL				0x01u
#define SHIFT_DELETE_CTRL				02u

#define SHIFT_ENCODER_WRITE				24u				//	24 ° bit

#define BIT_REMOCON_ON					0x01u			//	bit ġ
//#define BIT_POWER_CTRL					0x02u
#define BIT_DELETE_CTRL					0x04u

//	LED  
//#define LED_ALARM_ON					0x04u
#define LED_MOTOR_ON					0x01u
#define LED_MOTOR_OFF					0x00u
#define LED_ALL_OFF						0x00u

//	Mast  
#define SHIFT_MAST_ORIGIN				0x02u

//	 Ŭ
#define SHIFT_MAST_OVER_CURR			0x03u

//	 ˶
#define SHIFT_OVER_CURR					0x02u

//	ڴ  ġ ˶
#define SHIFT_ENCODER_ERR				0x06u

//	ڴ H/W 
#define SHIFT_ENCODER_HW_RESET			7u

//	ڴ HW  Ŭ
#define SHIFT_ENCODER_HW_RESET_CLEAR	4u

//	UDP  Ŀǵ
#define TCP_CMD_PERIOD_REPORT_STOP		0x00u
#define TCP_CMD_PERIOD_REPORT_START		0x40u


//  TCP/IP 
//  TCP MSG - TYPE
#define IDC_CMD_TYPE_DEVICE_PBIT        0x98u
#define IDC_CMD_TYPE_BIT_DETAIL         0x9Au
#define IDC_CMD_TYPE_MAST_CONTROL       0x9Bu
#define IDC_CMD_TYPE_DEVICE_ERASE       0x91u
#define IDC_CMD_TYPE_DEVICE_POWER       0x91u


//  UDP MSG TYPE
#define IDC_CMD_TYPE_STATUS_REPORT      0x90u
#define IDC_CMD_TYPE_HEART_BEAT         0x92u
#define IDC_CMD_TYPE_CBIT_REPORT        0x99u

//	ICD Sour/Dest Unit
#define ICD_CMD_UNIT_MP					0x61u
#define ICD_CMD_UNIT_MAST				0x40u

//	ICD TM
#define ICD_CMD_TM_TCP					0x24u
#define IDC_CMD_TM_UDP					0x04u

//	Simmulation Alarm
#define ICD_CMD_SIM_ALARM_RESET			0x00u			//	˶  
#define ICD_CMD_SIM_ALARM_SET			0x01u			//	˶  
//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------
//----------------------------------------tcp/ip setting---------------------------------------
//main.c define DEFAULT_IP_ADDRESS, DEFAULT_IP_MASK, DEFAULT_GW_ADDRESS Բ 
#define MY_IP_ADDR1						172u
#define MY_IP_ADDR2						16u
#define MY_IP_ADDR3						0u
#define MY_IP_ADDR4						50u

#define IPINFO_SIZE						6u

#define CHAR_SOUR						0x61u

//----------------------------------------TCP Server-------------------------------------------
#define NUM_TCP_CLIENT					2u
#define NUM_RECV_BUF					400u

#define MIN_TCP_SER_RCV_LEN				10u			//	ȿ ּ Ŷ 
#define LEN_COMPARE						3u			//	ȿ Ŷ ˻ 
#define LEN_ANT_MAST_START_REQ			10u			//	DeviceStart_Request Length
#define LEN_DEVICE_PBIT_REQ				10u			//	DevicePBIT_Request Length
#define LEN_DEVICE_BIT_DETAIL_REQ		11u			//	DeviceBITdetail_Request Length
#define LEN_ANT_MAST_CONTROL_REQ		11u			//	AntMastControl_Request Length, , 8 ~ 12(ڵ忡 ó)
#define LEN_DEVICE_ERASE_REQ			11u			//	DeviceErase_Request Length
#define LEN_DEVICE_POWER_REQ			11u			//	DevicePower_Request Length

#define LEN_SIM_ALARM_SET_REQ			12u			//	SimAlarmSet_Request Length
#define LEN_MAST_ORIGIN_SET_REQ			10u			//	MastOrigin_Set_Request Length

//----------------------------------------TCP Client-------------------------------------------
#define TCP_CLIENT_MY_PORT				61501u		//	TCP Client    24.06.27

#define TCP_MP_IP_ADDR1					172u		//	ӹ  IP Address
#define TCP_MP_IP_ADDR2					16u
#define TCP_MP_IP_ADDR3					0u
#define TCP_MP_IP_ADDR4					20u
#define TCP_MP_PORT						61202U		//	ӹ  Port

//----------------------------------------UDP Client-------------------------------------------
#define UDP_SERVER_IP_ADDRESS			"172.16.0.20"		//	172.16.x.x
#define UDP_SERVER_IP_ADDR1				172u
#define UDP_SERVER_IP_ADDR2				16u
#define UDP_SERVER_IP_ADDR3				0u
#define UDP_SERVER_IP_ADDR4				20u
#define UDP_SERVER_PORT					60202u		//	 24.06.27
#define UDP_MY_PORT						61501u

#define LEN_ANT_MAST_STATUS_REPORT		15u
#define LEN_ANT_MAST_CBIT_REPORT		12u
#define LEN_HEART_BEAT_DATA             11u
//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------

//	REGISTER INDEX
#define REG_IDX_0						0u
#define REG_IDX_1						1u
#define REG_IDX_2						2u
#define REG_IDX_3						3u
#define REG_IDX_4						4u
#define REG_IDX_5						5u
#define REG_IDX_6						6u
#define REG_IDX_7						7u
#define REG_IDX_8						8u
#define REG_IDX_9						9u
#define REG_IDX_10						10u
#define REG_IDX_11						11u
#define REG_IDX_12						12u



#define IIC_SCLK_RATE					100000u
#define TEST_BUFFER_SIZE				8u		//	EEPROM б/  
#define EEPROM_ADDR						0x50u	//	AT24C08C ⺻ I2C ּ, A2, A1, A0  0 


#endif	//	DEFINE_H



