#include "eeprom.h"
#include "ctrl_module.h"
#include "sleep.h"

u8 g_szIpInfo[IPINFO_SIZE] = { 0, };		//	IP Address, Port

//	EEPROM ʱȭ
void InitEeprom(void)
{
    XIicPs_Config *ConfigPtr;
    s32_t Status;
    u32_t nData;
    u32_t nRet;
	u8 cEepromBuf[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    xil_printf("InitEeprom Start\n");

    ConfigPtr = XIicPs_LookupConfig(XPAR_XIICPS_0_DEVICE_ID);
    if (NULL == ConfigPtr)
    {
#if DEBUG_COVER
    	xil_printf("No config found for %d\n", XPAR_XIICPS_0_DEVICE_ID);
#endif
    }
    else
    {
        Status = XIicPs_CfgInitialize(&Iic, ConfigPtr, ConfigPtr->BaseAddress);
        if (Status != XST_SUCCESS)
        {
#if DEBUG_COVER
            xil_printf("Initialization failed\n");
#endif
        }
        else
        {
            (void)XIicPs_SetSClk(&Iic, IIC_SCLK_RATE);

        	LoadEepromInfo(cEepromBuf);						//	Eeprom  ü б

        	if(cEepromBuf[1] == 0xFFu)						//	ʱȭ̸ 0 
        	{
        		g_cDeviceErase = 0u;
        	}
        	else											//	̸ 0 Ǵ 1
        	{
#if DEBUG_COVER
        		g_cDeviceErase = cEepromBuf[1];
#endif
        	}
            xil_printf("Init Eeprom g_cDeviceErase:%d\n\n", (u32_t)g_cDeviceErase);

            nData = cEepromBuf[2];
            g_nEncoderMT = nData << 16;
            nData = cEepromBuf[3];
            g_nEncoderMT += nData << 8;
            g_nEncoderMT += cEepromBuf[4];

            xil_printf("Init Eeprom g_nEncoderMT:%06X\n", g_nEncoderMT);

            xil_printf("InitEeprom End\n");
        }
    }
}


static s32 EepromWriteByte(XIicPs *IicInstance, u8 Address, u8 Data)
{
    s32_t Status, nRet = XST_SUCCESS;
    u8 Buffer[2];

    Buffer[0] = Address;  // 1Ʈ ּ   // ּ    
    Buffer[1] = Data;     // 

    Status = XIicPs_MasterSendPolled(IicInstance, Buffer, 2, EEPROM_ADDR);          // I2C   
    if (Status != XST_SUCCESS)
    {
#if DEBUG_COVER
    	nRet = Status;
#endif
    }
    else
    {
        while (XIicPs_BusIsBusy(IicInstance) == 1)
    	{
    		;  // I2C Ʈ Ϸ  
    	}

        (void)usleep(10000);              //    (ִ 10ms, EEPROM  Ʈ )
    }

    return nRet;
}


static s32 EepromReadByte(XIicPs *IicInstance, u8 Address, u8 *Data)
{
    s32_t Status, nRet = XST_SUCCESS;

   
    Status = XIicPs_MasterSendPolled(IicInstance, &Address, 1, EEPROM_ADDR);         // ּ 
    if (Status != XST_SUCCESS)
    {
#if DEBUG_COVER
    	nRet = Status;
#endif
    }
    else
    {
        while (XIicPs_BusIsBusy(IicInstance) == 1)
    	{
        	;  // I2C Ʈ Ϸ  
    	}

        Status = XIicPs_MasterRecvPolled(IicInstance, Data, 1, EEPROM_ADDR);            //  б
        if (Status != XST_SUCCESS)
        {
#if DEBUG_COVER
        	nRet = Status;
#endif
        }
    }
    
    return nRet;
}

//	ڴ Ƽϰ 
void SaveEncoderMT(u32 cVal)
{
    s32 Status = 0;
	u8 cAddr = 0x02;

    Status = EepromWriteByte(&Iic, cAddr, (u8_t)(cVal >> 16));			    	//	bit23 ~ 16       // EEPROM  
    if (Status != XST_SUCCESS)
	{
#if DEBUG_COVER
        xil_printf("EEPROM write failed\n");
#endif
    }
    else
    {
        xil_printf("encoder multiturn 1st write succeded:%X\n", (u32_t)(cVal >> 16));
    }

    (void)usleep(10000);

    Status = EepromWriteByte(&Iic, (u8_t)(cAddr + 1u), (u8_t)(cVal >> 8));	    //	bit15 ~ 8       // EEPROM  
    if (Status != XST_SUCCESS)
	{
#if DEBUG_COVER
        xil_printf("EEPROM write failed\n");
#endif
    }
    else
    {
        xil_printf("encoder multiturn 2nd write succeded:%X\n", (u32_t)(cVal >> 8));
    }

    (void)usleep(10000);

    Status = EepromWriteByte(&Iic, (u8_t)(cAddr + 2u), (u8_t)cVal);		    	//	bit7 ~ 0 
    if (Status != XST_SUCCESS)
	{
#if DEBUG_COVER
        xil_printf("EEPROM write failed\n");
#endif
    }
    else
    {
        xil_printf("encoder multiturn 3rd write succeded:%X\n", (u32_t)cVal);
    }

    return Status;
}

//	Eeprom  ü б
//	Eeprom Read  Address   ۵ ʴ 
//	߻Ͽ   о óϵ 
static void LoadEepromInfo(u8* cVal)
{
	u8 i = 1u;		//	Start Address
	s32_t Status;
	u8 cData = 0u;

    for(i = 0u; i < 5u; i++)
    {
    	Status = EepromReadByte(&Iic, i, &cData);
        if (Status != XST_SUCCESS)
        {
#if DEBUG_COVER
            xil_printf("EEPROM read failed\n");
#endif
        }
        else
        {
        	xil_printf("read addr:%d, cData:%X\r\n", (u32_t)i, (u32_t)cData);
        }
        cVal[i] = cData;		//	 
    }
}

