#include "tcp_client.h"

//	TCP Client ʱȭ
void InitTcpClient(void)
{
	IP_ADDR4(&g_ipaddrMP, TCP_MP_IP_ADDR1, TCP_MP_IP_ADDR2, TCP_MP_IP_ADDR3, TCP_MP_IP_ADDR4);		//	ӹ IP

	g_stTcpClientMy.cConnected = FALSE;
	(void)memset((void *)g_stTcpClientMy.szRecvData, (s32_t)0, (s32_t)(NUM_RECV_BUF * sizeof(u8_t)));
	g_stTcpClientMy.nRecvLen = 0;
	g_stTcpClientMy.cRecvFlag = FALSE;
	g_stTcpClientMy.cIsConnecting = FALSE;

	m_nConnectCnt = 0;
	g_nTcpDisconnectChk = 1u;	//	  ӹóS/W Heart Beat   5 ̻ Ǹ 

	tcp_client_connect();		//	TCP  
}

//	TCP  
static void tcp_client_connect(void)
{
	struct tcp_pcb *pcb;
	err_t err = 0;

	pcb = tcp_new();
	if(pcb != NULL)
	{
		xil_printf("TCP Client: tcp_new() ok.\n");
		ip_set_option(pcb, SOF_REUSEADDR);				//  sockoption ip, port  ɼ ߰
		err = tcp_bind(pcb, IP_ADDR_ANY, TCP_CLIENT_MY_PORT);
		g_stTcpClientMy.cIsConnecting = TRUE;
		if(err == (err_t)ERR_OK)
		{
			xil_printf("TCP Client: binding ok.\n");
			xil_printf("connecting to Server..\n");

			(void)tcp_connect(pcb, &g_ipaddrMP, TCP_MP_PORT, tcp_client_connected);
		}
		else
		{
#if DEBUG_COVER
			xil_printf("TCP Client: bind error.\n");
#endif
		}
	}
	else
	{
#if DEBUG_COVER
		xil_printf("TCP Client: Error creating PCB.\n");
#endif
	}
}

//	TCP  ݺ  
void ConnectToTcpServer(void)
{
	if(g_nTcpCliConCnt > TIMER_SEC1)
	{
		g_nTcpCliConCnt = 0u;

		if(g_stTcpClientMy.cConnected == FALSE)
		{
			m_nConDelayCnt++;

			if(m_nConDelayCnt > 5u)					//	5    õ
			{
				m_nConDelayCnt = 0u;
				if(g_stTcpClientMy.cIsConnecting == TRUE)
				{
					m_nConnectCnt++;
					xil_printf("\n\nConnect Count:%d\n\n", m_nConnectCnt);

					xil_printf("TCP Client: Close Client Socket\n");
					tcp_client_connection_close(g_stTcpClientMy.pcb);
					g_stTcpClientMy.cIsConnecting = FALSE;
				}
				else
				{
					xil_printf("TCP Client: Start Connecting to Server\n");
					tcp_client_connect();				//	TCP  
				}
			}
			else
			{
				if(g_stTcpClientMy.cIsConnecting == TRUE)
				{
					xil_printf("TCP Client: Waiting Connection...%d\n", (u32_t)m_nConDelayCnt);
				}
				else
				{
					xil_printf("TCP Client: Stay...%d\n", (u32_t)m_nConDelayCnt);
				}
			}
		}
	}
}

//	connect ݹ Լ
static err_t tcp_client_connected(void *arg, struct tcp_pcb *tpcb, err_t err)
{
	u32_t i;
	err_t ret_err = 0;
	u32_t ipaddr;
	void* Dummy;
	struct tcp_pcb *pPcb = NULL;

	Dummy = arg;

#if TEST_LOG_ON
	xil_printf("tcp_client_connected()\n\r");
#endif

	if(err == (err_t)ERR_OK)
	{
		if ((err != (err_t)ERR_OK) || (tpcb == NULL)) {
			ret_err = ERR_VAL;
		}

		ipaddr = tpcb->remote_ip.addr;
		xil_printf("accept() - %d.%d.%d.%d:%05d\r\n", (u32_t)(ipaddr & 0xFFu), (u32_t)((ipaddr >> 8) & 0xFFu), (u32_t)((ipaddr >> 16) & 0xFFu), (u32_t)((ipaddr >> 24) & 0xFFu), (u32_t)tpcb->remote_port);

		tcp_setprio(tpcb, TCP_PRIO_MIN);												//	set priority

		pPcb = (struct tcp_pcb*)mem_malloc(sizeof(struct tcp_pcb));
		if(pPcb != NULL)
		{
			pPcb = tpcb;

			tcp_arg((struct tcp_pcb*)tpcb, (void*)pPcb);
			tcp_recv((struct tcp_pcb*)tpcb, tcp_client_recv);
			tcp_sent((struct tcp_pcb*)tpcb, tcp_client_sent);
			tcp_poll((struct tcp_pcb*)tpcb, tcp_client_poll, 1);

			g_stTcpClientMy.cConnected = TRUE;
			g_stTcpClientMy.pcb = pPcb;
			g_stTcpClientMy.nRecvLen = 0;
			g_stTcpClientMy.cRecvFlag = FALSE;
			g_stTcpClientMy.cIsConnecting = FALSE;					//	 õ  , 

			g_nTcpDisconnectChk = 1;								//	  ӹóS/W Heart Beat   5 ̻ Ǹ 

			ret_err = (err_t)ERR_OK;
		}
		else
		{
			tcp_client_connection_close(tpcb);
			ret_err = ERR_MEM;

		}
	}
	else
	{
		ret_err = (err_t)ERR_OK;
	}

	return ret_err;

}

//	 ݹ Լ
static err_t tcp_client_recv(void *arg, struct tcp_pcb *tpcb, struct pbuf *p, err_t err)
{
	err_t ret_err;
	u32_t ipaddr;
	void* Dummy;

	Dummy = arg;

	if(p == NULL)
	{
#if TEST_LOG_ON
		xil_printf("tcp_client_recv() - p == NULL\r\n");
#endif

		ipaddr = tpcb->remote_ip.addr;
		xil_printf("tcp_client_recv() - p == NULL() - %d.%d.%d.%d:%05d\r\n", (u32_t)(ipaddr & 0xFFu), (u32_t)((ipaddr >> 8) & 0xFFu), (u32_t)((ipaddr >> 16) & 0xFFu), (u32_t)((ipaddr >> 24) & 0xFFu), (u32_t)tpcb->remote_port);

		tcp_client_connection_close(tpcb);

		ret_err = (err_t)ERR_OK;
	}
	else if(err != (err_t)ERR_OK)
	{
#if TEST_LOG_ON
		xil_printf("tcp_client_recv() - ERR\r\n");
#endif
		if(p != NULL)
		{
			(void)pbuf_free(p);
		}

		ret_err = err;
	}
	else
	{
		g_stTcpClientMy.cRecvFlag = TRUE;
		if(p->len < (u32_t)NUM_RECV_BUF)
		{
			(void)memcpy((void*)&g_stTcpClientMy.szRecvData[0], (const void*)p->payload, (size_t)p->len);
		}
		g_stTcpClientMy.nRecvLen = p->len;

		ret_err = (err_t)ERR_OK;
	}

	return (err_t)ret_err;
}

//	ACK  ݹ Լ
static err_t tcp_client_sent(void *arg, struct tcp_pcb *tpcb, u16_t len)
{
	u16_t nLenDummy = len;
	u32_t ipaddr;
	const struct tcp_pcb *pcbDummy = tpcb;
	void *Dummy;

	Dummy= arg;

	ipaddr = tpcb->remote_ip.addr;
	ipaddr += 1u;

	return (err_t)ERR_OK;
}

//	poll ݹ Լ
static err_t tcp_client_poll(void *arg, struct tcp_pcb *tpcb)
{
	err_t ret_err = (err_t)ERR_OK;
	u32_t ipaddr;
	void *Dummy;

	Dummy= arg;

	ipaddr = tpcb->remote_ip.addr;
	ipaddr += 1u;

	LWIP_UNUSED_ARG(arg);

	u8_t i = 0u;

	struct tcp_pcb *pcbDummy = tpcb;

	return (err_t)ret_err;
}

//	client socket  ó
void tcp_client_connection_close(struct tcp_pcb* tpcb)
{
	err_t err;
	u32_t ipaddr;

	m_nConDelayCnt = 0u;			//	 Ǵ ī ʱȭ
	g_nBitDetailHBCnt = 0u;
	g_nTcpDisconnectChk = 0u;		//	  ӹóS/W Heart Beat   5 ̻ Ǹ 

	ipaddr = tpcb->remote_ip.addr;
	xil_printf("tcp_client_connection_close() - %d.%d.%d.%d:%05d\r\n", (u32_t)(ipaddr & 0xFFu), (u32_t)((ipaddr >> 8) & 0xFFu), (u32_t)((ipaddr >> 16) & 0xFFu), (u32_t)((ipaddr >> 24) & 0xFFu), (u32_t)tpcb->remote_port);

	g_stTcpClientMy.cConnected = FALSE;
	(void)memset((void *)g_stTcpClientMy.szRecvData, (s32_t)0, (s32_t)(NUM_RECV_BUF * sizeof(u8_t)));
	g_stTcpClientMy.nRecvLen = 0u;
	g_stTcpClientMy.cRecvFlag = FALSE;
	g_stTcpClientMy.cIsConnecting = FALSE;

	tcp_arg(tpcb, NULL);			//	callback 
	tcp_recv(tpcb, NULL);
	tcp_sent(tpcb, NULL);
	tcp_poll(tpcb, NULL, 0u);

	err = tcp_close(tpcb);
	if (err != (err_t)ERR_OK)
	{
		tcp_abort(tpcb);			// Free memory with abort
	}
}












