#include "udp_client.h"

//	UDP Server ʱȭ
void InitUdpServer(void)
{
	s8_t err;
	ip_addr_t addr;


	InitUdpClientMember();				//	UDP Client ü ʱȭ

	/* Create Client PCB */
	g_stUdpCliPcb.pcb = udp_new();
	if(g_stUdpCliPcb.pcb != NULL)
	{
		err = udp_bind(g_stUdpCliPcb.pcb, IP_ADDR_ANY, UDP_MY_PORT);

		if(err == (s8_t)ERR_OK)
		{
			xil_printf("udp server binding ok\n");
			udp_recv(g_stUdpCliPcb.pcb, udp_server_receive_callback, NULL);

			IP_ADDR4(&addr, UDP_SERVER_IP_ADDR1, UDP_SERVER_IP_ADDR2, UDP_SERVER_IP_ADDR3, UDP_SERVER_IP_ADDR4);		//	ӹ IP
			g_stUdpCliPcb.pcb->remote_ip.addr = addr.addr;						//	۽ó  Ȯ
			g_stUdpCliPcb.pcb->remote_port = 61202;		//	51271
		}
		else
		{
#if DEBUG_COVER
			xil_printf("udp server binding error\n");
#endif
		}
	}
}

static void udp_server_receive_callback(void *arg, struct udp_pcb *upcb, struct pbuf *p, ip_addr_t *addr, u16_t port)
{
	uint8_t i;
	u8_t szBuff[100];
	void *Dummy;
	struct udp_pcb* pDummyPcb;
	ip_addr_t* pDummyAddr;
	u16_t DummyPort;

	Dummy = arg;
	pDummyPcb = upcb;
	pDummyAddr = addr;
	DummyPort = port;
	DummyPort++;


#if TEST_LOG_ON_UDP
	xil_printf("udp recv:%s:%d\r\n", ip4addr_ntoa((const ip_addr_t *)addr), port);
#endif

	if(p->len < 100u)
	{
		(void)memcpy((void*)szBuff, (const void*)(p->payload), (size_t)p->len);

		if((szBuff[0] == 0x92u) && (szBuff[1] == 0x10u) && (szBuff[2] == 0x40u) && (szBuff[3] == 0x61u))	//	ӹó Heart Beat   ˻
		{
			m_cRecvHBFromMP = 1;
			
			g_nBitDetailHBCnt = 0;				//	ī ʱȭ
			g_cBitDetailHBErr = 0;				//	Heart Beat  On ()

			g_nTcpDisconnectCnt = 0;			//	ī ʱȭ,   ӹó S/W Heart Beat ̼ 5 ̻ ߻ Ȯο ī
			g_nTcpDisconnectChk = 1;			//	 ,   ӹóS/W Heart Beat   5 ̻ Ǹ 
		}
	}

	(void)pbuf_free(p);		/* Free the p buffer */
}

//	UDP Client ü ʱȭ
static void InitUdpClientMember(void)
{
	m_cRecvHBFromMP = 1;
	g_cBitDetailHBErr = 0;

	g_unUdpServerPort = UDP_SERVER_PORT;

	g_stUdpCliPcb.nRecvLen = 0;
	(void)memset((void*)g_stUdpCliPcb.szRecvData, (s32_t)0, (size_t)(NUM_RECV_BUF * sizeof(u8_t)));
	g_stUdpCliPcb.cRecvFlag = FALSE;
}

//	UDP  ó
void UdpCommProcess(void)
{
	UdpCommPeriod();		//	UDP ֱ  ó

	if(g_nBitDetailHBCnt > TIMER_SEC3)
	{
		g_nBitDetailHBCnt = 0;				//	ī ʱȭ
		g_cBitDetailHBErr = 1;				//	Heart Beat   
	}
	if(g_nTcpDisconnectCnt > TIMER_SEC10)
	{
		g_nTcpDisconnectCnt = 0;
		g_nTcpDisconnectChk = 0;			//	 ,   ӹóS/W Heart Beat   5 ̻ Ǹ 

		if(g_stTcpClientMy.cConnected == TRUE)
		{
			tcp_client_connection_close(g_stTcpClientMy.pcb);
		}
	}
}

//	UDP ֱ  ó
static void UdpCommPeriod(void)
{
	if(g_nReportCnt > TIMER_MSEC333)		//	main() - makeTiming()
	{
		g_nReportCnt = 0u;

		if(m_cReportIdx == 0u)
		{
			m_cReportIdx++;
			if(m_cRecvHBFromMP == 1u)						//	ӹó Heart Beat ŵǸ  
			{
				if(g_cMastPeriodSendCmd == TCP_CMD_PERIOD_REPORT_START)
				{
					FuncAntMastStatusReport();				//	׳ Ʈ   ۽
				}
			}
		}
		else if(m_cReportIdx == 1u)
		{
			m_cReportIdx++;
			if(m_cRecvHBFromMP == 1u)						//	ӹó Heart Beat ŵǸ  
			{
				if(g_cMastPeriodSendCmd == TCP_CMD_PERIOD_REPORT_START)
				{
					FuncAntMastCBitReport();				//	׳ Ʈ CBIT  ۽
				}
			}
		}
		else// if(m_cReportIdx == 2u)			//	    
		{
			m_cReportIdx = 0u;
			FuncHeartBeatData();				//	LAN Ἲ Ȯ 
		}
	}
}

//	׳ Ʈ   ۽
static void FuncAntMastStatusReport(void)
{
	u32_t i = 0;
	u8_t szBuf[LEN_ANT_MAST_STATUS_REPORT + ARR_BUF_MARGIN];
	struct pbuf *p = NULL;

	(void)memset((void*)szBuf, (s32_t)0, (size_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_STATUS_REPORT;	//	Type
	szBuf[i++] = 0x04u;							//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;				//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;				//	Dest
	szBuf[i++] = (u8_t)g_cSn;					//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = IDC_CMD_TM_UDP;				//	TM
	szBuf[i++] = 0x05u;							//	Length
	szBuf[i++] = 0x00u;							//	Length
	szBuf[i++] = 0x00u;							//	Length
	szBuf[i++] = 0x00u;							//	Length

	if(g_cMastRcvCmd == 0x00u)
	{
		szBuf[i++] = 0x00u;		//	׳Ʈ  
	}
	else
	{
		szBuf[i++] = 0x40u;		//	׳Ʈ  
	}

	szBuf[i++] = (u8_t)g_nMastCurrHeight & 0xFFu;			//	 ̰ Է
	szBuf[i++] = (u8_t)(g_nMastCurrHeight >> 8) & 0xFFu;	//	 ̰ Է
	szBuf[i++] = (u8_t)(g_nMastCurrHeight >> 16) & 0xFFu;	//	 ̰ Է
	szBuf[i++] = (u8_t)(g_nMastCurrHeight >> 24) & 0xFFu;	//	 ̰ Է

	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		(void)pbuf_take((struct pbuf*)p, (const void*)(u8_t*)szBuf, (u16_t)i);
		(void)udp_sendto((struct udp_pcb*)g_stUdpCliPcb.pcb, (struct pbuf*)p, (const ip_addr_t*)&g_stUdpCliPcb.pcb->remote_ip, (u16_t)g_stUdpCliPcb.pcb->remote_port);
		(void)pbuf_free(p);
	}
	else
	{
#if DEBUG_COVER
		xil_printf("error allocating pbuf to send\r\n");
#endif
	}
}

//	׳ Ʈ CBIT  ۽
static void FuncAntMastCBitReport(void)
{
	u32_t i = 0;
	u8_t szBuf[LEN_ANT_MAST_CBIT_REPORT + ARR_BUF_MARGIN];
	u8_t cData = 0;
	struct pbuf *p = NULL;

	(void)memset((void*)szBuf, (s32_t)0, (size_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_CBIT_REPORT;	//	Type
	szBuf[i++] = 0x05u;						//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;			//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;			//	Dest
	szBuf[i++] = (u8_t)g_cSn;				//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = IDC_CMD_TM_UDP;			//	TM
	szBuf[i++] = 0x02u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length

	if((g_cBitDetailHBErr == 1u) || (g_cEncoderErrFlag == 1u))		//	ֿ켱 :   Ǵ ڴ 
	{
		szBuf[i++] = 0x0Au;					//	Function	׳Ʈ Ȯ/ 0x02,  0x08 = 00001010b = 0x0A

		if(g_cBitDetailHBErr == 1u)			//	 
		{
			szBuf[i++] = 0x07u;				//	Device		׳Ʈ Bit0: 1,  Bit1: 1, Ϻ Bit2: 1 = 0x05
		}
		else
		{
			szBuf[i++] = 0x05u;				//	Device		׳Ʈ Bit0: 1,  Bit1: 0, Ϻ Bit2: 1 = 0x05
		}
	}
	else if(g_cOverCurrFlag == 1u)
	{
		szBuf[i++] = 0x05u;					//	Function	׳Ʈ Ȯ/ 0x02,  0x08 = 00001010b = 0x0A
		szBuf[i++] = 0x05u;					//	Device		׳Ʈ Bit0: 1,  Bit1: 0, Ϻ Bit2: 1 = 0x05
	}
	else
	{
		szBuf[i++] = 0x00u;
		szBuf[i++] = 0x00u;
	}

	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		(void)pbuf_take((struct pbuf*)p, (const void*)(u8_t*)szBuf, (u16_t)i);
		(void)udp_sendto((struct udp_pcb*)g_stUdpCliPcb.pcb, (struct pbuf*)p, (const ip_addr_t*)&g_stUdpCliPcb.pcb->remote_ip, (u16_t)g_stUdpCliPcb.pcb->remote_port);
		(void)pbuf_free(p);
	}
	else
	{
#if DEBUG_COVER
		xil_printf("error allocating pbuf to send\r\n");
#endif
	}
}

//	LAN Ἲ Ȯ 
static void FuncHeartBeatData(void)
{
	u32_t i = 0;
	u8_t szBuf[LEN_HEART_BEAT_DATA + ARR_BUF_MARGIN];
	struct pbuf *p = NULL;

	(void)memset((void*)szBuf, (s32_t)0, (size_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_HEART_BEAT;	//	Type
	szBuf[i++] = 0x10u;						//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;			//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;			//	Dest
	szBuf[i++] = (u8_t)g_cSn;				//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = IDC_CMD_TM_UDP;			//	TM
	szBuf[i++] = 0x01u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Reserved

	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		(void)pbuf_take((struct pbuf*)p, (const void*)(u8_t*)szBuf, (u16_t)i);
		(void)udp_sendto((struct udp_pcb*)g_stUdpCliPcb.pcb, (struct pbuf*)p, (const ip_addr_t*)&g_stUdpCliPcb.pcb->remote_ip, (u16_t)g_stUdpCliPcb.pcb->remote_port);
		(void)pbuf_free(p);
	}
	else
	{
#if DEBUG_COVER
		xil_printf("error allocating pbuf to send\r\n");
#endif
	}
}
